#! /usr/bin/env python

import gtk
import GtkExtra
from libglade import *
import cPickle
import socket
from nntplib import *
from os import remove
from rfc822 import parsedate
from mimify import mime_decode_header,mime_encode_header
from string import find,replace
from StringIO import *
import quopri

FAKEWIN=gtk.GtkWindow()
pix_read,mask_read=gtk.create_pixmap_from_xpm(FAKEWIN,None,"pixmaps/msg_read.xpm")
pix_fup,mask_fup=gtk.create_pixmap_from_xpm(FAKEWIN,None,"pixmaps/msg_fup.xpm")

def window1_destroy(obj):
    #closing connection with server
    s.quit()
    gtk.mainquit()

def parse_config():
    global conf
    try:
        f=open("config","r")
    except IOError:
        sbar_win1.push(1,"Missing \"config\" file. Please exit and create it.")
        GtkExtra.message_box("Missing Config file", "Please configure your profile. Run File > Configure...",("Close",))

        return 0
    else:
        #parsing config file to a dict
        lista=f.readlines()
        conf={}
        for i in range(len(lista)):
            ind=lista[i].rfind("=")
            if ind>0:
                left=lista[i][0:ind].strip()
                right=lista[i].strip()[ind+1:].strip()
                conf[left]=right
        return 1

def init():
    "Program Initialization"
    global s
    #loading conf file
    ret=parse_config()
    if ret==1:
        #reading the subscribed groups
        show_subscribed_win1()
        #setting the font
        font_name=conf["font_name"]
        if font_name!="":
            style=text_article_win1.get_style().copy()
            style.font=gtk.load_font(font_name)
            text_article_win1.set_style(style)
        #opening connection with server
        try:
            s=NNTP(conf["server"])
        except socket.error:
            sbar_win1.push(1,"No connection estabilished with server")
            


def show_subscribed_win1():
    "show subscribed groups in window1"
    clist_subscribed_win1.clear()
    try:
        f=open("group_info/subscribed.dat","r")
    except IOError:
        clist_subscribed_win1.append(("No groups subscribed","",""))
    else:
        subscribed_groups=cPickle.load(f)
        for i in range(len(subscribed_groups)):
            unread=open("group_info/"+subscribed_groups[i][0],"r")
            unread_articles=cPickle.load(unread)
            unread.close()
            number_unread=repr(len(unread_articles))
            clist_subscribed_win1.append((subscribed_groups[i][0],number_unread))
        f.close()

def group_select_from_subiscribed(obj,row,column,event):
    global group_to_read
    global row_group_to_read
    group_to_read=clist_subscribed_win1.get_text(row,0)
    row_group_to_read=row
    clist_subscribed_win1.moveto(row,0,0.4,0)
    thread_group(group_to_read)

def parse_header(list):
    ref=""
    fup_to=""
    ct_enc=""
    i=0
    while i in range(len(list)):
        ind=list[i].find(":")
        header_name=list[i][:ind].strip()
        if header_name=="From":
            from_name=mime_decode_header(list[i][ind+1:].strip())
        elif header_name=="Subject":
            subj=mime_decode_header(list[i][ind+1:].strip())
        elif header_name=="Date":
            date=list[i][ind+1:].strip()
        elif header_name=="References":        
            ref=list[i][ind+1:].strip()
            j=i+1
            while (list[j][0]==" " or list[j][0]=="<"):
                #the references is splitted among 2 lines or more
                ref=ref+list[j].strip()
                j=j+1
                i=i+1
        elif header_name=="Followup-To":
            fup_to=list[i][ind+1:].strip()
        elif header_name=="Content-Transfer-Encoding":
            ct_enc=list[i][ind+1:].strip()
        i=i+1    
    nick=parse_from(from_name)
    date_parsed=parse_date(date)
    return nick,from_name,ref,fup_to,ct_enc,subj,date,date_parsed
        
def parse_from(from_name):
    left=from_name.rfind("<")
    if left!=-1:
        # It is like "nick" <email> or nick <email>
        if from_name[0]=="\"":
            #It is like "nick" <email>
            nick=from_name[1:left-2].strip()
        else:
            #it is like nick <email>
            nick=from_name[0:left].strip()
    else:        
        left=from_name.rfind("(")
        if left!=-1:
            #it is like email (nick)
            right=from_name.rfind(")")
            nick=from_name[left+1:right].strip()
        else:
            #ther is only the email
            nick=from_name
    return nick
    
    
def parse_date(date):
    data=parsedate(date)
    if data[3]<10:
        ora="0"+repr(data[3])
    else:
        ora=repr(data[3])
    if data[4]<10:
        minuti="0"+repr(data[4])
    else:
        minuti=repr(data[4])
    return repr(data[2])+"/"+repr(data[1])+"/"+repr(data[0])+" "+ora+":"+minuti


def thread_group(group):
    global row_article_to_read
    row_article_to_read=-1
    ctree_thread_win1.set_line_style(gtk.CTREE_LINES_DOTTED)

    resp,count,first,last,name=s.group(group)
    f=open("group_info/"+group,"r")
    unread_articles=cPickle.load(f)
    f.close()

    ctree_thread_win1.clear()
    ctree_thread_win1.freeze()

    #the loop starts
    dict={}
    j=0
    for i in range(len(unread_articles)):
        try:
            resp,number,msgid,header_list=s.head(unread_articles[j][1])
        except NNTPTemporaryError:
            unread_articles.remove(unread_articles[j])
        else:
            nick,from_name,ref,fup_to,ct_enc,subj,date,date_parsed=parse_header(header_list)
            number=unread_articles[j][0]
            if ref=="":
                "Root node"
                node=ctree_thread_win1.insert_node(None,None,(subj,"",nick,date_parsed),5,None,None,None,None,gtk.FALSE,gtk.FALSE)
            else:
                "Child node"
                idx=ref.rindex("<")
                last_ref=ref[idx:]
                node_mom=dict.get(last_ref,None)
                "return the node of the parent if it's in list, else None"
                node=ctree_thread_win1.insert_node(node_mom,None,(subj,"",nick,date_parsed),5,None,None,None,None,gtk.FALSE,gtk.FALSE)

            dict[msgid]=node
            j=j+1
            ctree_thread_win1.node_set_row_data(node,[msgid,number,subj,from_name,date,ref,fup_to,ct_enc])
            message="Threading "+repr(j)+"/"+repr(len(unread_articles))+" ..."
            sbar_win1.push(1,message)
            while gtk.events_pending():
                gtk.mainiteration(gtk.FALSE)
                
    ctree_thread_win1.thaw()
    f=open("group_info/"+group,"w")
    cPickle.dump(unread_articles,f,1)
    f.close()
    message=group+" selected"
    sbar_win1.push(1,message)


def article_select_from_thread(obj,row,column,event):
    global row_article_to_read
    row_article_to_read=row
    node=ctree_thread_win1.node_nth(row)
    try:
        pix,mask=ctree_thread_win1.node_get_pixmap(node,1)
    except ValueError:
        ctree_thread_win1.node_set_pixmap(node,1,pix_read,mask_read)
    
    ctree_thread_win1.expand(node)
    ctree_thread_win1.moveto(row,0,0.4,0)
    article_to_read=ctree_thread_win1.node_get_row_data(node)
    show_article(article_to_read)
    #remove article from unreads
    f=open("group_info/"+group_to_read,"r")
    unread_articles=cPickle.load(f)
    f.close()
    ind=0
    success=0
    i=0
    while i<len(unread_articles) and success!=1:
        if article_to_read[0]==unread_articles[i][1]:
            ind=i
            success=1
            number=clist_subscribed_win1.get_text(row_group_to_read,1)
            clist_subscribed_win1.set_text(row_group_to_read,1,repr(int(number)-1))
            unread_articles.remove(unread_articles[ind])
        i=i+1
    
    f=open("group_info/"+group_to_read,"w")
    cPickle.dump(unread_articles,f,1)
    f.close()

def decode_qp_article(article):
    i=0
    j=0
    body=[]
    while i in range(len(article)):
        body.append(article[i])
        if i<len(article)-1:
            if article[i][-1:]=="=":
                body[j]=body[j][:-1]+article[i+1]
                i=i+1          
        i=i+1
        j=j+1
    out=[]    
    for i in range(len(body)):
        line_encoded=StringIO(body[i])
        line_decoded=StringIO("")
        quopri.decode(line_encoded,line_decoded)
        out.append(line_decoded.getvalue())
        out[i]=replace(out[i],"\r","")
        line_encoded.close()
        line_decoded.close()
    return out

    
def rot13(s):
    "Rot13 the string passed"
    string_coded = ""
    dic={'a':'n','b':'o','c':'p','d':'q','e':'r','f':'s','g':'t',
         'h':'u','i':'v','j':'w','k':'x','l':'y','m':'z',
         'n':'a','o':'b','p':'c','q':'d','r':'e','s':'f','t':'g',
         'u':'h','v':'i','w':'j','x':'k','y':'l','z':'m',
         'A':'N','B':'O','C':'P','D':'Q','E':'R','F':'S','G':'T',
         'H':'U','I':'V','J':'W','K':'X','L':'Y','M':'Z',
         'N':'A','O':'B','P':'C','Q':'D','R':'E','S':'F','T':'G',
         'U':'H','V':'I','W':'J','X':'K','Y':'L','Z':'M'}
    for c in s:
        char=dic.get(c,c)
        string_coded=string_coded+char
    return string_coded

def show_article(article):
    global raw
    raw=0
    resp,number,id,list=s.body(article[0])  
    enc=article[7]
    if enc=="quoted-printable" or enc=="QUOTED-PRINTABLE":
        list=decode_qp_article(list)

    label_from_win1.set_text(article[3])
    label_subject_win1.set_text(article[2])
    label_date_win1.set_text(article[4])
    render_article(list)

def render_article(article):
    text_article_win1.freeze()
    text_article_win1.delete_text(0,-1) 
    colormap=text_article_win1.get_colormap()

    #loading colors
    try:
        text_color=conf["text_color"]
    except KeyError:
        text_color=None
    else:
        text_color=text_color[1:-1].split(",")
        for i in range(len(text_color)):
            text_color[i]=float(text_color[i])
        text_color=apply(colormap.alloc,map(lambda color: int(color*65535.0), text_color))
    try:
        quote_color=conf["quote_color"]
    except KeyError:
        quote_color=None
    else:
        quote_color=quote_color[1:-1].split(",")
        for i in range(len(quote_color)):
            quote_color[i]=float(quote_color[i])
        quote_color=apply(colormap.alloc,map(lambda color: int(color*65535.0), quote_color))
               
    try: 
        sign_color=conf["sign_color"]
    except KeyError:
        sign_color=None
    else:
        sign_color=sign_color[1:-1].split(",")
        for i in range(len(sign_color)):
            sign_color[i]=float(sign_color[i])
        sign_color=apply(colormap.alloc,map(lambda color: int(color*65535.0), sign_color))
    
    color=text_color
    for i in range(len(article)):
        if len(article[i])>0:
            if article[i][0]==">":
                text_article_win1.insert(None,quote_color,None,article[i])
            elif len(article[i])>1:
                if (len(article[i])==2 and article[i][0:2]=="--") or (len(article[i])==3 and article[i][0:3]=="-- "):
                    text_article_win1.insert(None,sign_color,None,article[i])
                    color=sign_color
                else:
                    text_article_win1.insert(None,color,None,article[i])
        text_article_win1.insert_defaults("\n")
    text_article_win1.thaw()

                
              
        

def open_window2(obj):
    window2.show()

def button_get_new_headers(obj):
    "Download new headers for the subscibed"
    try:
        f=open("group_info/subscribed.dat","r")
    except IOError:
        sbar_win1.push(1,"No subscribed groups")
    else:
        subscribed=cPickle.load(f)
        f.close()
        f=open("group_info/subscribed.dat","w")
        for i in range(len(subscribed)):
            unread=open("group_info/"+subscribed[i][0],"r")
            unread_articles=cPickle.load(unread)
            unread.close()
            resp,count,first,last,name=s.group(subscribed[i][0])
            old_last=int(subscribed[i][1])
            if (old_last+1)<=int(last):
                subscribed[i][1]=last
                resp,msgid=s.xhdr("message-id",repr(old_last+1)+"-"+last)
                for j in range(len(msgid)):
                    message="Downloading header for: "+subscribed[i][0]+" : article "+repr(j)+"/"+repr(len(msgid))
                    sbar_win1.push(1,message)
                    unread_articles.append((msgid[j][0],msgid[j][1]))
                unread=open("group_info/"+subscribed[i][0],"w")
                cPickle.dump(unread_articles,unread,1)
                unread.close()
        cPickle.dump(subscribed,f,1)
        f.close()
        sbar_win1.push(1,"Dowload completed")
        show_subscribed_win1()

def button_expand(obj):
    "Expand all"
    nodes=ctree_thread_win1.base_nodes()
    ctree_thread_win1.freeze()
    for i in range(len(nodes)):
        ctree_thread_win1.expand_recursive(nodes[i])
    ctree_thread_win1.thaw()

def button_collapse(obj):
    "Collapse all"
    nodes=ctree_thread_win1.base_nodes()
    ctree_thread_win1.freeze()
    for i in range(len(nodes)):
        ctree_thread_win1.collapse_recursive(nodes[i])
    ctree_thread_win1.thaw()

def button_mark_group(obj):
    "Mark group read"    
    f=open("group_info/"+group_to_read,"w")
    unread_articles=[]
    cPickle.dump(unread_articles,f,1)
    f.close()
    show_subscribed_win1()
    thread_group(group_to_read)

def button_mark_all(obj):
    "Mark all groups read"
    try:
        f=open("group_info/subscribed.dat","r")
    except IOError:
        pass
    else:
        subscribed=cPickle.load(f)
        f.close()
        for i in range(len(subscribed)):
            f=open("group_info/"+subscribed[i][0],"w")
            unread_articles=[]
            cPickle.dump(unread_articles,f,1)
            f.close()
        show_subscribed_win1()        

def button_next_article(obj):
    ctree_thread_win1.select_row(row_article_to_read+1,0)

def button_prev_article(obj):
    if row_article_to_read>0:
        row=row_article_to_read-1
    else:
        row=0
    ctree_thread_win1.select_row(row,0)

def button_raw_article(obj):
    global raw
    node=ctree_thread_win1.node_nth(row_article_to_read)
    article=ctree_thread_win1.node_get_row_data(node)
    if raw==0:
        resp,number,id,list=s.article(article[0])
        render_article(list)
        raw=1
    else:
        show_article(article)
    
def button_post_article(obj):
    global article_subject
    global article_newsgroups
    global article_references
    article_references=""
    article_subject=""
    article_newsgroups=group_to_read
    text_article_win4.delete_text(0,-1)
    window4.show()
    return 1

def button_followup_article(obj):
    global article_subject
    global article_newsgroups
    global article_references
    article_subject=label_subject_win1.get()
    if ((article_subject[0:3]!="Re:") and (article_subject[0:3]!="re:")):
        article_subject="Re: "+article_subject
    node=ctree_thread_win1.node_nth(row_article_to_read)
    article=ctree_thread_win1.node_get_row_data(node)

    article_references=article[5]
    followup_to=article[6]
    if followup_to!="":
        article_newsgroups=followup_to
    else:
        article_newsgroups=group_to_read
    article_references=article_references+" "+article[0]
   
    #building the article
    length=text_article_win1.get_length()
    article=text_article_win1.get_chars(0,length)
    list=article.split('\n')
    quoted_list=[]
    original_from=parse_from(label_from_win1.get())
    quoted_list.append(""+original_from+" wrote: ")
    sign=0   
    for i in range(len(list)):
        if (len(list[i])==2 and list[i][0:2]=="--") or (len(list[i])==3 and list[i][0:3]=="-- "):
            sign=1
        if sign!=1:    
            quoted_list.append(">"+list[i])
     
    text_article_win4.delete_text(0,-1)
    colormap=window1.get_colormap()
      
    #loading colors
    try:
        text_color=conf["text_color"]
    except KeyError:
        text_color=None
    else:
        text_color=text_color[1:-1].split(",")
        for i in range(len(text_color)):
            text_color[i]=float(text_color[i])
        text_color=apply(colormap.alloc,map(lambda color: int(color*65535.0), text_color))
    try:
        quote_color=conf["quote_color"]
    except KeyError:
        quote_color=None
    else:
        quote_color=quote_color[1:-1].split(",")
        for i in range(len(quote_color)):
            quote_color[i]=float(quote_color[i])
        quote_color=apply(colormap.alloc,map(lambda color: int(color*65535.0), quote_color))

    text_article_win4.freeze()       
    text_article_win4.insert(None,text_color,None,quoted_list[0]+"\n\n")
    for i in range(len(quoted_list))[1:]:
        text_article_win4.insert(None,quote_color,None,quoted_list[i])
        text_article_win4.insert_defaults("\n")
    text_article_win4.thaw()

    #changing the icon
    node=ctree_thread_win1.node_nth(row_article_to_read)
    ctree_thread_win1.node_set_pixmap(node,1,pix_fup,mask_fup)
      
    window4.show()
    return 1

def button_apply_rot13_win1(obj):
    start_sel = text_article_win1.selection_start_pos
    end_sel = text_article_win1.selection_end_pos
    if start_sel>end_sel:
        mom=start_sel
        start_sel=end_sel
        end_sel=mom
    text = text_article_win1.get_chars(start_sel, end_sel)
    text=rot13(text)
    text_article_win1.delete_text(start_sel, end_sel)
    text_article_win1.insert(None,None,None,text)

def view_next_group(obj):
    clist_subscribed_win1.select_row(row_group_to_read+1,0) 

def view_parent_article(obj):
    node_son=ctree_thread_win1.node_nth(row_article_to_read)
    article=ctree_thread_win1.node_get_row_data(node_son)
    refs=article[5]
    if refs=="":
        sbar_win1.push(1,"This is a root article")
    else:
        idx=refs.rindex("<")
        last_ref=refs[idx:]
        try:
            resp,number,msgid,header_list=s.head(last_ref)
        except NNTPTemporaryError:
            sbar_win1.push(1,"This article is not present on the server")
        else:
            #First search the parent in the threaded articles
            i=row_article_to_read
            success=0
            while i>=0 and success==0:
                node=ctree_thread_win1.node_nth(i)
                article_mom=ctree_thread_win1.node_get_row_data(node)
                if article_mom[0]==msgid:
                    #It is in the threaded, let's show the article selecting its row
                    ctree_thread_win1.select_row(i,0)
                    success=1
                else:
                    i=i-1
            if success==0:
                #If it is not in the threaded article let's insert a node for this article
                nick,from_name,ref,fup_to,ct_enc,subj,date,date_parsed=parse_header(header_list)
                #Attention when the article is a xposted, number is not correct!!!!!!!
                article=[msgid,number,subj,from_name,date,ref,fup_to,ct_enc]
                node_ins=ctree_thread_win1.insert_node(None,node_son,(subj,"",nick,date_parsed),5,None,None,None,None,gtk.FALSE,gtk.FALSE)
                ctree_thread_win1.node_set_row_data(node_ins,article)
                ctree_thread_win1.select_row(row_article_to_read,0)
            sbar_win1.push(1,"Article loaded")

def show_subscribed_win2():
    "show subscribed groups in window2"
    clist_subscribed_win2.clear()
    try:
        f=open("group_info/subscribed.dat","r")
    except IOError:
        clist_subscribed_win1.append(("No groups subscribed","",""))
    else:
        subscribed_groups=cPickle.load(f)
        for i in range(len(subscribed_groups)):
            clist_subscribed_win2.append((subscribed_groups[i][0],))
        f.close()

def show_groups_win2(list):
    "show the newsgroups list"
    clist_groups_win2.clear()
    clist_groups_win2.freeze()
    for i in range(len(list)):
        clist_groups_win2.append((list[i][0],list[i][3]))
    clist_groups_win2.thaw()
        
    
def window2_delete_event(arg1,arg2):
    "Destroy window2"
    window2.hide()
    return 1    

def button_close_win2(obj):
    window2.hide()
    return 1

def button_get_newsgroups_list(obj):
    "Fetch the newsgroups list"
    server_name=conf["server"]
    clist_groups_win2.clear()
    try:
        s=NNTP(server_name)
    except socket.error:
        sbar_win2.push(1,"No connection estabilished, please control the server name")
    else:
        sbar_win2.push(1,"Please Wait, I'm dowloading the newsgroups list from server :"+server_name)
        resp,list=s.list()
        f=open("group_info/groups.dat","w")
        show_groups_win2(list)
        cPickle.dump(list,f,1)
        f.close()
        sbar_win2.push(1, "List Downloaded")
        s.quit()

def group_select_from_list_add(obj,row,column,event):
    global group_to_subscribe
    group_to_subscribe=clist_groups_win2.get_text(row,0)

def button_add_subscribed(obj):
    global group_to_subscribe
    try:
        s=NNTP(conf["server"])
    except socket.error:
        sbar_win2.push(1,"No connection estabilished, please control the server name")
    else:
        resp,count,first,last,name=s.group(group_to_subscribe)
        subscribed_groups=[]
        #read the subscribed file 
        try:
            f=open("group_info/subscribed.dat","r")
        except IOError:
            subscribed_groups.append([group_to_subscribe,last])            
        else:
            subscribed_groups=cPickle.load(f)
            if group_to_subscribe !="":
                already_in=0
                for i in range(len(subscribed_groups)):
                    if subscribed_groups[i][0]==group_to_subscribe:
                        already_in=1
                if already_in==0:        
                    subscribed_groups.append([group_to_subscribe,last])
            f.close()
        #refresh the subscribed file
        try:
            f=open("group_info/subscribed.dat","w")
        except IOError:
            sbar_win2.push(1,"Problems while opening subscribed.dat")
        else:
            article_number=spin_art_number_win2.get_value_as_int()
            if article_number>int(count):
                article_number=int(count)
            subscribed_groups.sort()
            cPickle.dump(subscribed_groups,f,1)
            f.close()
            
            #dowload the msg-ids for the subscribed group
            f=open("group_info/"+group_to_subscribe,"w")
            unread_articles=[]
            first=repr(int(last)-article_number+1)
            resp,msgid=s.xhdr("message-id",first+"-"+last)
            for i in range(len(msgid)):
                unread_articles.append((msgid[i][0],msgid[i][1]))
                message=" Downloading msg-id: "+repr(i)+"/"+repr(len(msgid))
                sbar_win2.push(1,message)
                while gtk.events_pending():
                    gtk.mainiteration(gtk.FALSE)
            sbar_win2.push(1,"Group subscribed")
            cPickle.dump(unread_articles,f,1)
            f.close()

            #refresh the subiscrebed groups lists
            show_subscribed_win2()
            show_subscribed_win1()
        s.quit()

def group_select_from_list_remove(obj,row,column,event):
    global group_to_remove
    group_to_remove=clist_subscribed_win2.get_text(row,0)

def button_remove_subscribed(obj):
    global group_to_remove
    try:
        f=open("group_info/subscribed.dat","r")
    except IOError:
        clist_subscribed_win2.clear()
        clist_subscribed_win2.append(("No groups subiscribed",))
    else:
        subscribed=cPickle.load(f)
        f.close()
        success=0
        i=0
        while (i<len(subscribed)) and (success==0):
            if group_to_remove==subscribed[i][0]:
                success=1
                subscribed.remove(subscribed[i])
                remove("group_info/"+group_to_remove)
                sbar_win2.push(1,"Group removed")
            i=i+1
        try:
            f=open("group_info/subscribed.dat","w")
        except IOError:
            clist_subscribed_win2.clear()
            clist_subscribed_win2.append(("Problems while opening subscribed.dat",))
        else:
            cPickle.dump(subscribed,f,1)
            f.close()
            show_subscribed_win2()
            show_subscribed_win1()
            
def button_search_group(obj):
    group_to_search=entry_search_group_win2.get_text()
    try:
        f=open("group_info/groups.dat","r")
    except IOError:
        sbar_win2.push(1,"You have to dowload the newsgroups list")
    else:
        list=cPickle.load(f)
        f.close()
        i=0
        found=[]
        clist_groups_win2.clear()
        while (i<len(list)):
            if  find(list[i][0],group_to_search)!=-1:
                found=(list[i])
                clist_groups_win2.append((found[0],found[3]))
            i=i+1

def button_show_full_list(obj):
    try:
        f=open("group_info/groups.dat","r")
    except IOError:
        sbar_win2.push(1,"You have to dowload the newsgroups list")
    else:
        list=cPickle.load(f)
        f.close()
        show_groups_win2(list)

        
def window2_show(obj):
    label_server_win2.set_text(conf["server"])
    try:
        f=open("group_info/groups.dat","r")
    except IOError:
        clist_groups_win2.append(("unavailable",""))
        sbar_win2.push(1,"You have to download the newsgroups list")
    else:
        list=cPickle.load(f)
        show_groups_win2(list)
        f.close()
    show_subscribed_win2()

def button_open_font_dialog(obj):
    try:
        font_name=conf["font_name"]
    except KeyError:
        pass
    else:
        font_selection_dialog.set_font_name(font_name)
    font_selection_dialog.show()
    
def font_selection_delete_event(arg1,arg2):
    font_selection_dialog.hide()
    return 1

def button_set_font(obj):
    font_name=font_selection_dialog.get_font_name()
    font_selection_dialog.hide()    
    style=text_article_win1.get_style().copy()
    style.font=gtk.load_font(font_name)
    text_article_win1.set_style(style) 
    entry_font_name.set_text(font_name)
    return 1

def button_apply_font(obj):
    font=font_selection_dialog.get_font()
    font_name=font_selection_dialog.get_font_name()
    style=text_article_win1.get_style().copy()
    style.font=gtk.load_font(font_name)
    text_article_win1.set_style(style)    
    entry_font_name.set_text(font_name)


def button_close_font_dialog(obj):
    font_selection_dialog.hide()
    return 1

def button_save_config(obj):
    global conf
    conf["server"]=entry_server.get_text()
    conf["nick"]=entry_nick.get_text()
    conf["email"]=entry_email.get_text()
    conf["sign"]=entry_sign.get_text()
    conf["font_name"]=entry_font_name.get_text()
    conf["charset"]=combo_charset.entry.get_text()
    f=open("config","w")
    list=conf.keys()
    for i in range(len(list)):
        f.write(list[i]+"="+conf[list[i]]+"\n")
    f.close()
    config_window.hide()
    return 1

def config_window_delete_event(arg1,arg2):
    config_window.hide()
    return 1

def config_window_show(obj):
    try:
        server=conf["server"]
    except KeyError:
        server="Not Set"
    try:
        nick=conf["nick"]
    except KeyError:
        nick="Not Set"
    try:
        email=conf["email"]
    except KeyError:
        email="Not Set"
    try:
        sign=conf["sign"]
    except KeyError:
        sign="Not Set"
    try:
        font_name=conf["font_name"]
    except KeyError:
        font_name=""
    try:
        text_color=conf["text_color"]
    except KeyError:
        text_color=(0,0,0)
    else:
        text_color=text_color[1:-1].split(",")
        for i in range(len(text_color)):
            text_color[i]=float(text_color[i])
    try:
        quote_color=conf["quote_color"]
    except KeyError:
        quote_color=(0,0,0)
    else:
        quote_color=quote_color[1:-1].split(",")
        for i in range(len(quote_color)):
            quote_color[i]=float(quote_color[i])
    try:
        sign_color=conf["sign_color"]
    except KeyError:
        sign_color=(0,0,0)
    else:
        sign_color=sign_color[1:-1].split(",")
        for i in range(len(sign_color)):
            sign_color[i]=float(sign_color[i])
    
    try:
        charset=conf["charset"]
    except KeyError:
        charset="ISO-8859-1"
        
    entry_server.set_text(server)
    entry_nick.set_text(nick)
    entry_email.set_text(email)
    entry_sign.set_text(sign)
    entry_font_name.set_text(font_name)
    combo_charset.entry.set_text(charset)
    
    colormap=entry_text_color.get_colormap()
    style=entry_text_color.get_style().copy()
    gdk_color=apply(colormap.alloc,map(lambda color: int(color*65535.0), text_color))
    style.fg[gtk.STATE_NORMAL]=gdk_color
    entry_text_color.set_style(style)
    
    style=entry_quote_color.get_style().copy()
    gdk_color=apply(colormap.alloc,map(lambda color: int(color*65535.0), quote_color))
    style.fg[gtk.STATE_NORMAL]=gdk_color
    entry_quote_color.set_style(style)

    style=entry_sign_color.get_style().copy()
    gdk_color=apply(colormap.alloc,map(lambda color: int(color*65535.0), sign_color))
    style.fg[gtk.STATE_NORMAL]=gdk_color
    entry_sign_color.set_style(style)


def button_change_color_text(obj):
    global color_changed
    color_changed="text"
    color_selection_dialog.show()
    return 1

def button_change_color_quote(obj):
    global color_changed
    color_changed="quote"
    color_selection_dialog.show()
    return 1
    
def button_change_color_sign(obj):
    global color_changed
    color_changed="sign"
    color_selection_dialog.show()
    return 1


def button_set_color(obj):
    colormap=entry_text_color.get_colormap()
    colordata=color_selection_dialog.colorsel.get_color()
    style=entry_text_color.get_style().copy()
    gdk_color=apply(colormap.alloc,map(lambda color: int(color*65535.0), colordata))
    style.fg[gtk.STATE_NORMAL]=gdk_color
    if color_changed=="text":
        entry_text_color.set_style(style)
        conf["text_color"]=repr(colordata)
    if color_changed=="quote":
        entry_quote_color.set_style(style)
        conf["quote_color"]=repr(colordata)
    if color_changed=="sign":
        entry_sign_color.set_style(style)
        conf["sign_color"]=repr(colordata)
    color_selection_dialog.hide()
    return 1

def color_selection_delete_event(arg1,arg2):
    color_selection_dialog.hide()
    return 1

def button_close_color_dialog(obj):
    color_selection_dialog.hide()
    return 1

def button_open_config_window(obj):
    config_window.show()
    return 1

def window4_show(obj):
    entry_newsgroups_win4.set_text(article_newsgroups)
    entry_from_win4.set_text(conf["nick"]+" <"+conf["email"]+">")
    entry_subject_win4.set_text(article_subject)
    font_name=conf["font_name"]
    if font_name!="":
        style=text_article_win4.get_style().copy()
        style.font=gtk.load_font(font_name)
        text_article_win4.set_style(style)

    text_article_win4.freeze()
    position=text_article_win4.get_position()
    #append the sign
    text_article_win4.insert_defaults("\n-- \n")
    sign_file=open(conf["sign"],"r")
    sign=sign_file.readlines()
    for i in range(len(sign)):
        text_article_win4.insert_defaults(sign[i])
    text_article_win4.thaw()
    sign_file.close()     
    text_article_win4.set_position(position)



def window4_delete_event(arg1,arg2):
    window4.hide()
    return 1
    

def button_discard_article(obj):
    window4.hide()
    return 1

def button_send_article(obj):
    global article_references
    article="Newsgroups: "+entry_newsgroups_win4.get_text()+"\n"
    article=article+"From: "+mime_encode_header(entry_from_win4.get_text())+"\n"
    article=article+"Subject: "+mime_encode_header(entry_subject_win4.get_text())+"\n"
    if article_references!="":
        article=article+"References: "+article_references+"\n"
    article_references=""
    article=article+"User-Agent: XPN ver.0.0.5 (the second impact)\n"
    article=article+"MIME-Version: 1.0\n"
    try:
        output_charset=conf["charset"]
    except KeyError:
        output_charset="ISO-8859-1"
    article=article+"Content-Type: text/plain; charset="+output_charset+"\n"
    article=article+"Content-Transfer-Encoding: 8bit\n\n"

    length=text_article_win4.get_length()
    body=text_article_win4.get_chars(0,length)
    list=body.split('\n')    

    #trying to detect the charset from the font name
    try:    
        font_name=conf["font_name"]
    except KeyError:
        #I guess that the input charset is latin-1
        input_charset="ISO-8859-1"
    else:
        if font_name.find("iso8859-15")!=-1:
            input_charset="ISO-8859-15"
        elif font_name.find("iso8859-1")!=-1:
            input_charset="ISO-8859-1"
        else:
            input_charset="ISO-8859-1"

    for i in range(len(list)):
        #I decode the string according to the charset chosen for the text widget
        string=unicode(list[i]+"\n",input_charset)
        #I encode the string according to the charset chosen for the output
        string=string.encode(output_charset,"replace")
        article=article+string
    f=open("article","w")
    f.write(article)
    f.close()
    try:
        s=NNTP(conf["server"])
    except socket.error:
        sbar_win1.push(1,"No connection estabilished")        
    else:
        f=open("article","r")
        s.post(f)
        f.close()
        s.quit()
    window4.hide()
    return 1
    

def button_apply_rot13_win4(obj):
    start_sel = text_article_win4.selection_start_pos
    end_sel = text_article_win4.selection_end_pos
    if start_sel>end_sel:
        mom=start_sel
        start_sel=end_sel
        end_sel=mom
    text = text_article_win4.get_chars(start_sel, end_sel)
    text=rot13(text)
    text_article_win4.delete_text(start_sel, end_sel)
    text_article_win4.insert(None,None,None,text)

def text_article_win4_changed(obj):
    text = text_article_win4.get_chars(0, text_article_win4.get_length())
    pos = text_article_win4.get_point()
    lines= text[:pos].split("\n")
    line=lines[-1]
    if len(line)==73:
        "We have to wrap"
        if text[pos-1] !=" ":
            "this word will bi moved on the next line"
            success=0
            i=0            
            while success==0:
                "seeking the beginning of the word"
                char=text_article_win4.get_chars(pos-i-1,pos-i)
                if char==" ":
                    success=1
                    word=text_article_win4.get_chars(pos-i,pos)
                    text_article_win4.delete_text(pos-i,pos)
                    text_article_win4.insert(None,None,None,"\n"+word)
                else:
                    i=i+1
        else:
            "just going next line"
            text_article_win4.delete_text(pos-1,pos)
            text_article_win4.insert(None,None,None,"\n")


def open_dialog_about(obj):
    dialog_about.show()
    return 1

def dialog_about_delete_event(arg1,arg2):
    dialog_about.hide()
    return 1
    
def button_ok_dialog(obj):
    dialog_about.hide()
    return 1
    
interface = GladeXML ("xpn.glade")
dic =  {"on_window1_destroy":window1_destroy,
        "on_button1_clicked":open_window2,
        "on_button2_clicked":button_get_new_headers,
        "on_button3_clicked":button_expand,
        "on_button15_clicked":button_collapse,
        "on_button16_clicked":button_mark_group,
        "on_button17_clicked":button_mark_all,
        "on_button18_clicked":button_prev_article,
        "on_button19_clicked":button_next_article,
        "on_button20_clicked":button_raw_article,
        "on_button21_clicked":button_followup_article,
        "on_button22_clicked":button_post_article,
        "on_button23_clicked":button_apply_rot13_win1,
        "on_button24_clicked":button_open_config_window,
        "on_view_next_group1_activate":view_next_group,
        "on_go_parent_article1_activate":view_parent_article,
        "on_clist1_select_row":group_select_from_subiscribed,
        "on_ctree1_select_row":article_select_from_thread,
        "on_window2_delete_event":window2_delete_event,
        "on_window2_show":window2_show,
        "on_button4_clicked":button_add_subscribed,
        "on_button5_clicked":button_remove_subscribed,
        "on_button6_clicked":button_get_newsgroups_list,
        "on_button7_clicked":button_close_win2,
        "on_button8_clicked":button_search_group,
        "on_button9_clicked":button_show_full_list,
        "on_clist2_select_row":group_select_from_list_add,
        "on_clist3_select_row":group_select_from_list_remove,
        "on_fontselectiondialog1_delete_event":font_selection_delete_event,
        "on_ok_button1_clicked":button_set_font,
        "on_apply_button1_clicked":button_apply_font,
        "on_cancel_button1_clicked":button_close_font_dialog,
        "on_button10_clicked":button_save_config,
        "on_button11_clicked":button_open_font_dialog,
        "on_button12_clicked":button_change_color_text,
        "on_button13_clicked":button_change_color_quote,
        "on_button14_clicked":button_change_color_sign,
        "on_window3_show":config_window_show,
        "on_window3_delete_event":config_window_delete_event,
        "on_colorselectiondialog1_delete_event":color_selection_delete_event,
        "on_ok_button2_clicked":button_set_color,
        "on_cancel_button2_clicked":button_close_color_dialog,
        "on_window4_show":window4_show,
        "on_window4_delete_event":window4_delete_event,
        "on_button25_clicked":button_send_article,
        "on_button26_clicked":button_discard_article,
        "on_button28_clicked":button_apply_rot13_win4,
        "on_text2_changed":text_article_win4_changed,
        "on_about1_activate":open_dialog_about,
        "on_dialog1_delete_event":dialog_about_delete_event,
        "on_button27_clicked":button_ok_dialog}
        
interface.signal_autoconnect(dic)

#window1 widgets
window1=interface.get_widget("window1")
sbar_win1=interface.get_widget("statusbar1")
clist_subscribed_win1=interface.get_widget("clist1")
ctree_thread_win1=interface.get_widget("ctree1")
text_article_win1=interface.get_widget("text1")
label_from_win1=interface.get_widget("label31")
label_subject_win1=interface.get_widget("label29")
label_date_win1=interface.get_widget("label33")

#window2 widgets
window2=interface.get_widget("window2")
clist_groups_win2=interface.get_widget("clist2")
clist_subscribed_win2=interface.get_widget("clist3")
sbar_win2=interface.get_widget("statusbar2")
label_server_win2=interface.get_widget("label18")
spin_art_number_win2=interface.get_widget("spinbutton1")
entry_search_group_win2=interface.get_widget("entry1")

#gtkfontselectiondialog
font_selection_dialog=interface.get_widget("fontselectiondialog1")

#config_window widgets
config_window=interface.get_widget("window3")
entry_server=interface.get_widget("entry2")
entry_nick=interface.get_widget("entry3")
entry_email=interface.get_widget("entry4")
entry_sign=interface.get_widget("entry5")
entry_font_name=interface.get_widget("entry6")
entry_text_color=interface.get_widget("entry7")
entry_quote_color=interface.get_widget("entry8")
entry_sign_color=interface.get_widget("entry9")
combo_charset=interface.get_widget("combo1")

#gtlcolorselectiondialog
color_selection_dialog=interface.get_widget("colorselectiondialog1")

#window4 widgets
window4=interface.get_widget("window4")
entry_newsgroups_win4=interface.get_widget("entry10")
entry_from_win4=interface.get_widget("entry11")
entry_subject_win4=interface.get_widget("entry12")
text_article_win4=interface.get_widget("text2")


#dialog about widgets
dialog_about=interface.get_widget("dialog1")
button_ok_dialog=interface.get_widget("button27")


conf={}
init()
gtk.mainloop()
